"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SmallVariant(ProtocolElement):
    """
    A reported variant
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "reportEvents",
        "variantCalls",
        "variantCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "reportEvents": reports_6_2_0.ReportEvent,
            "variantAttributes": reports_6_2_0.VariantAttributes,
            "variantCalls": reports_6_2_0.VariantCall,
            "variantCoordinates": reports_6_2_0.VariantCoordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import reports as reports_6_2_0

        return {
            "org.gel.models.report.avro.ReportEvent": reports_6_2_0.ReportEvent,
            "org.gel.models.report.avro.VariantAttributes": reports_6_2_0.VariantAttributes,
            "org.gel.models.report.avro.VariantCall": reports_6_2_0.VariantCall,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_2_0.VariantCoordinates,
            "org.gel.models.report.avro.SmallVariant": reports_6_2_0.SmallVariant,
        }

    __slots__ = [
        "reportEvents",
        "variantCalls",
        "variantCoordinates",
        "variantAttributes",
    ]

    def __init__(
        self,
        reportEvents,
        variantCalls,
        variantCoordinates,
        variantAttributes=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_2_0.SmallVariant model.

        :param reportEvents:
            The list of report events for this variant across multiple modes of
            inheritance and panels
        :type reportEvents: list[ReportEvent]
        :param variantCalls:
            List of variant calls across all samples under analysis for this
            variant
        :type variantCalls: list[VariantCall]
        :param variantCoordinates:
            The variant coordinates. Chromosome is either 1-22, X, Y, MT or any
            other contif in the reference genome,         no "chr"
            prefix is expected. Position is 1- based. Reference and
            alternate should never be empty or any         character
            representing emptiness (e.g.: . or -), a VCF-like indel
            representation is expected.
        :type variantCoordinates: VariantCoordinates
        :param variantAttributes:
        :type variantAttributes: None | VariantAttributes
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.2.0"
